@use "sass:color";
// Default mixins and settings -----------------
@import "../template/mixins";
@import "../template/settings";
// ---------------------------------------------
@import "../nunito";
@import "../fira_code";

@mixin material-card-box-shadow {
  box-shadow:
    0 14px 28px rgba(0, 0, 0, 0.25),
    0 10px 10px rgba(0, 0, 0, 0.22);
}

// Include theme-specific fonts
$systemFontsSansSerif:
  "Nunito Variable",
  -apple-system,
  BlinkMacSystemFont,
  avenir next,
  avenir,
  segoe ui,
  helvetica neue,
  helvetica,
  Cantarell,
  Ubuntu,
  roboto,
  noto,
  arial,
  sans-serif;
$systemFontsMono:
  Menlo,
  Consolas,
  Monaco,
  Liberation Mono,
  Lucida Console,
  monospace;

html * {
  color-profile: sRGB;
  rendering-intent: auto;
}

// 00000000   0.67645822   0.34786758
$sepiaTintR: 255;
$sepiaTintG: 255 * 0.77645822;
$sepiaTintB: 255 * 0.74786758;

@function sepiaTint($color) {
  @return $color;
  @return color.change(
    $color,
    $red: red($color) * $sepiaTintR/255,
    $green: green($color) * $sepiaTintG/255,
    $blue: blue($color) * $sepiaTintB/255
  );
  //@return color.adjust($color, $hue: 45deg);
}

$background: sepiaTint(#282a36);
$foreground: sepiaTint(#f8f8f2);
$selection: sepiaTint(#44475a);
$comment: sepiaTint(#6272a4);
$red: sepiaTint(#ff5555);
$orange: sepiaTint(#ffb86c);
$yellow: sepiaTint(#f1fa8c);
$green: sepiaTint(#50fa7b);
$purple: sepiaTint(#bd93f9);
$cyan: sepiaTint(#8be9fd);
$pink: sepiaTint(#ff79c6);

$heading1Size: 2.77em;
$heading2Size: 2.11em;
$heading3Size: 1.75em;
$heading4Size: 1em;

$NEON_BRIGHTNESS: 0.55;

@mixin neon-red {
  color: sepiaTint(#fff5f6);
  text-shadow:
    0 0 2px sepiaTint(#000),
    0 0 10px rgba(sepiaTint(#fc1f2c), $NEON_BRIGHTNESS),
    0 0 5px rgba(sepiaTint(#fc1f2c), $NEON_BRIGHTNESS),
    0 0 25px rgba(sepiaTint(#fc1f2c), $NEON_BRIGHTNESS);
  backface-visibility: hidden;
}

@mixin neon-pink {
  color: sepiaTint(#f92aad);
  text-shadow:
    0 0 2px sepiaTint(#100c0f),
    0 0 5px sepiaTint(#dc078e33),
    0 0 10px sepiaTint(#fff3);
  backface-visibility: hidden;
}

@mixin neon-pink-box-shadow {
  box-shadow:
    0 0 2px sepiaTint(#100c0f),
    0 0 5px sepiaTint(#dc078e92),
    0 0 10px sepiaTint(#fff3);
  backface-visibility: hidden;
}

@mixin neon-pink-box-shadow-big {
  box-shadow:
    0 0 2px sepiaTint(#100c0f),
    0 0 5px sepiaTint(#dc078e33),
    0 0 10px sepiaTint(#fff3);
  backface-visibility: hidden;
}

.neon-pink-box-shadow {
  @include neon-pink-box-shadow();
}

svg.neon-pink {
  fill: sepiaTint(#f92aad);
  filter: drop-shadow(0 0 3px sepiaTint(#100c0f)) drop-shadow(0 0 15px sepiaTint(#dc078e33))
    drop-shadow(0 0 20px sepiaTint(#fff3));
  backface-visibility: hidden;
}

@mixin neon-yellow {
  color: sepiaTint(#f4eee4);
  text-shadow:
    0 0 2px sepiaTint(#393a33),
    0 0 8px rgba(sepiaTint(#f39f05), $NEON_BRIGHTNESS),
    0 0 2px rgba(sepiaTint(#f39f05), $NEON_BRIGHTNESS);
  backface-visibility: hidden;
}

@mixin neon-green {
  color: sepiaTint(#72f1b8);
  text-shadow:
    0 0 2px sepiaTint(#100c0f),
    0 0 10px rgba(sepiaTint(#257c55), $NEON_BRIGHTNESS),
    0 0 35px rgba(sepiaTint(#678274), $NEON_BRIGHTNESS);
  backface-visibility: hidden;
}

@mixin neon-blue {
  color: sepiaTint(#fdfdfd);
  text-shadow:
    0 0 2px sepiaTint(#001716),
    0 0 3px rgba(sepiaTint(#03edf9), $NEON_BRIGHTNESS),
    0 0 5px rgba(sepiaTint(#03edf9), $NEON_BRIGHTNESS),
    0 0 8px rgba(sepiaTint(#03edf9), $NEON_BRIGHTNESS);
  backface-visibility: hidden;
}

@mixin bodyBackground {
  background-color: transparent !important;
  background-image: linear-gradient(to bottom, sepiaTint(#2a2139) 75%, sepiaTint(#34294f));
  background-size: auto 100vh;
  background-position: top;
  background-repeat: no-repeat;
}

.reveal .small {
  font-size: 0.8em;
}

.reveal .smaller {
  font-size: 0.6em;
}

.reveal .avatar {
  height: 150px;
  border-radius: 5px;
  @include neon-pink-box-shadow-big();
}

.reveal .flex {
  display: flex;
}

.reveal .flex-row {
  flex-direction: row;
}

.reveal .flex-column {
  flex-direction: column;
}

.reveal .flex-align-center {
  align-items: center;
}

.reveal .flex-align-baseline {
  align-items: baseline;
}

.reveal .flex-distribute > * {
  flex: 1 1 0;
}

.reveal .flex-gap {
  gap: 16px;
}

.reveal .flex-column-reverse {
  flex-direction: column-reverse;
}

// Override theme settings (see ../template/settings.scss)
$mainColor: $foreground;
$headingColor: $purple;
$headingTextShadow: none;
$headingTextTransform: none;
$headingFontWeight: bold;
$backgroundColor: $background;
$linkColor: $pink;
$linkColorHover: $cyan;
$selectionBackgroundColor: $selection;
$inlineCodeColor: $green;
$listBulletColor: $cyan;

$mainFont: $systemFontsSansSerif;
$headingFont: $systemFontsSansSerif;
$codeFont: "Fira Code", $systemFontsMono;

// Change text colors against light slide backgrounds
@include light-bg-text-color($background);

// Theme template ------------------------------
@import "../template/theme";
// ---------------------------------------------

// Define additional color effects based on Dracula spec
// https://spec.draculatheme.com/
:root {
  --r-bold-color: #{$orange};
  --r-italic-color: #{$yellow};
  --r-inline-code-color: #{$inlineCodeColor};
  --r-list-bullet-color: #{$listBulletColor};
}

.reveal strong,
.reveal b {
  color: var(--r-bold-color);
}

.reveal .pipeline.pipeline-inline {
  flex-direction: row;
  justify-content: center;
  gap: 16px;

  > div {
    flex: 1 1 0;
  }
}

@mixin pipeline-item-blur {
  background: color.change($purple, $alpha: 0.4);
}

.reveal .chapter {
  position: absolute;
  top: calc(-1 * var(--slide-top-offset));
  left: 0;
  font-size: 0.4em;
}

.reveal .toggle {
  position: absolute;
  top: calc(-1 * var(--slide-top-offset));
  right: 0;
  padding: 16px;
  font-size: 0.4em;
  z-index: 99999;
}

.reveal .pipeline {
  .pipeline-item {
    font-size: 0.8em;
    background: $purple;
    border-radius: 16px;
    padding: 16px;
    @include material-card-box-shadow();
    display: flex;
    flex-direction: column;
    justify-content: center;
    white-space: nowrap;

    &.pipeline-item-blur {
      @include pipeline-item-blur();
    }

    &.pipeline-item-small {
      padding: 4px;
      font-size: 0.4em;
    }
    &.pipeline-item-smaller {
      padding: 1px;
      font-size: 0.2em;
    }
  }

  .pipeline-arrow {
    flex: 0 !important;
    align-self: center;
    text-align: center;
    font-size: 0.5em;
    &::before {
      content: "▶";
    }
  }

  .pipeline-item-group {
    display: flex;
    flex-direction: column;
    justify-content: center;
    gap: 6px 6px;
    .pipeline-item {
      flex: 1;
    }
  }
  .pipeline-item-group-bracket {
    background: url(/dist/bracket.svg);
    background-size: 100% 100%;
    content: " ";
    flex-grow: 0 !important;
    flex-basis: 20px !important;
    flex-shrink: 0 !important;
    margin: 0 0 0 -10px;
  }

  .pipeline-item-sequence {
    display: flex;
    flex-direction: row;
    justify-content: center;
    gap: 6px 6px;
    .pipeline-item {
      flex: 1;
    }
  }
}

.reveal .pipeline-container {
  display: flex;
  align-items: center;

  .pipeline-content {
    flex-grow: 1;
  }

  .pipeline > div {
    &:not(:last-child) {
      @include pipeline-item-blur();
    }
  }
}

@media (orientation: landscape) {
  .reveal .fullsize {
    position: absolute;

    --slide-height-diff-from-viewport: calc(100vh - (var(--slide-height) * var(--slide-scale)));
    top: calc(-1 * var(--slide-top-offset) - var(--slide-height-diff-from-viewport) / 2 / var(--slide-scale));

    --slide-width-diff-from-viewport: calc(100vw - (var(--slide-width) * var(--slide-scale)));
    left: calc(-1 * var(--slide-width-diff-from-viewport) / 2 / var(--slide-scale));

    height: calc(100vh / var(--slide-scale));
    width: calc(100vw / var(--slide-scale));
  }

  .reveal .slide-top {
    position: relative;
    top: calc(-1 * var(--slide-top-offset));
  }

  .reveal .slide-left {
    position: relative;
    --slide-width-diff-from-viewport: calc(100vw - (var(--slide-width) * var(--slide-scale)));
    left: calc(-1 * var(--slide-width-diff-from-viewport) / 2 / var(--slide-scale));
    margin-right: calc(-1 * var(--slide-width-diff-from-viewport) / 2 / var(--slide-scale));
  }

  .reveal .pipeline-container .pipeline {
    width: 150px;
    --slide-width-diff-from-viewport: calc(100vw - (var(--slide-width) * var(--slide-scale)));
    --offset: calc(-1 * var(--slide-width-diff-from-viewport) / 2 / var(--slide-scale));

    margin-left: calc(-1 * max(-100px, var(--offset)));
    margin-right: 32px;

    height: calc(100vh / var(--slide-scale));
    align-items: stretch;
    justify-content: center;
    flex-direction: column;
  }

  .reveal .pipeline-container .pipeline-content {
    align-self: start;
    margin-top: 20px;
  }

  .reveal .pipeline {
    display: flex;
    gap: 32px;

    align-items: stretch;
    justify-content: center;
  }
}

@media (orientation: portrait) {
  .reveal .pipeline-container {
    flex-direction: column;
    gap: 32px;
  }

  .reveal .pipeline {
    display: flex;
    flex-direction: row;
    gap: 32px;
    align-items: stretch;
    justify-content: center;
  }
  .reveal .pipeline-container .pipeline-content {
    align-self: center;
  }
}

.reveal ul li {
  white-space: normal;
}

.overview todo {
  &:before {
    background: rgba(255, 0, 0, 0.2);
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    position: absolute;
  }
}

todo {
  &:before {
    position: absolute;

    --slide-height-diff-from-viewport: calc(100vh - (var(--slide-height) * var(--slide-scale)));
    top: calc(-1 * var(--slide-top-offset) - var(--slide-height-diff-from-viewport) / 2 / var(--slide-scale));

    --slide-width-diff-from-viewport: calc(100vw - (var(--slide-width) * var(--slide-scale)));
    left: calc(-1 * var(--slide-width-diff-from-viewport) / 2 / var(--slide-scale));

    width: calc(100vw / var(--slide-scale));
    background: $red;
    color: white;
    font-size: 12px;

    content: "TODO ON THIS PAGE";
  }
}

body.has-todos {
  &:after {
    position: absolute;
    content: "TODOs left in the slides";
    display: block;
    left: 0;
    bottom: 0;
    right: 0;
    text-align: center;
    font-weight: bold;
    font-size: 1em;
    color: $red;
  }
}

todo {
  display: block;
  font-weight: bold;
  color: $red;
}

.reveal em,
.reveal i,
.reveal blockquote {
  color: var(--r-italic-color);
}

.reveal code {
  color: var(--r-inline-code-color);
}

// Dracula colored list bullets and numbers
.reveal ul,
.reveal ul ul {
  list-style: none;
}

.reveal ul li::before {
  content: "•";
  color: var(--r-list-bullet-color);
  display: inline-block;
  width: 1em;
  margin-left: -1em;
}

.reveal ol {
  list-style: none;
  counter-reset: li;
}

.reveal ol li::before {
  content: counter(li) ".";
  color: var(--r-list-bullet-color);
  display: inline-block;
  width: 2em;

  margin-left: -2.5em;
  margin-right: 0.5em;
  text-align: right;
}

.reveal ol li {
  counter-increment: li;
}

.reveal .width-100pct {
  width: 100%
}

.reveal {
  h1,
  .h1 {
    @include neon-pink();
  }

  h2,
  .h2 {
    @include neon-green();
  }

  h3,
  .h3 {
    @include neon-yellow();
    text-transform: uppercase;
  }
}

.reveal p:not(:last-child) {
  margin-bottom: 1em;
}

.reveal .indent {
  margin-left: 1em;
  display: inline-block;
}

.reveal .progress span {
  background: linear-gradient(to right, sepiaTint(#fc28a8), sepiaTint(#03edf9)) !important;
}

.reveal .hljs {
  padding: 18px;
  border-radius: 18px;
  min-height: unset;
}

:not(pre) > code {
  padding: 0 5px;
  border-radius: 5px;
  background: $backgroundColor;
}
